      PROGRAM EX0707
      DIMENSION T12F(5),T21F(5),G1S(5),G2S(5)
      DATA G1INF,G2INF,A12,T12FIRST,T12LAST/3.06,3.91,-1,-5.,5./
      SUMABS=9999.
      IJ=0
      T12=T12FIRST
      WRITE (*,1000)
 1000 FORMAT(2X,'SOLUTION NO      T12       T21    |T12|+|T21|   A12')
C
C     Scan range for solutions
C
   50 T12=T12+.0001
      T21=LOG(G1INF)-T12*EXP(-A12*T12)
      T12N=LOG(G2INF)-T21*EXP(-A12*T21)
      IF ((ABS((T12-T12N)/T12N)*100.).GT.0.005) GOTO 70
      IJ=IJ+1
      SUM=ABS(T12)+ABS(T21)
      WRITE (*,1100) IJ,T12,T21,SUM
 1100 FORMAT(6X,I2,5X,2F10.4,F11.3)
      T12F(IJ)=T12
      T21F(IJ)=T21
      IF (SUM.GT.SUMABS) GOTO 60
      SUMABS=SUM
      ISOL=IJ
   60 T12=T12+0.1
   70 IF (T12.GT.T12LAST) GOTO 100
      GOTO 50
C
C     Optimum solution (Tassios criterion)
C
  100 WRITE(*,1200) T12F(ISOL),T21F(ISOL),A12
 1200 FORMAT(2X,/2X,'OPTIMUM SET',2F10.4,16X,F7.4)
C
C     Tables of all activity coefficients
C
      WRITE(*,1400) T12F(1),T21F(1),T12F(2),T21F(2),T12F(3),T21F(3)
 1400 FORMAT(1X/,10X,3(5X,'T12',6X,'T21    '),/,7X,3(5X,F7.4,2X,F7.4), 
     &/,1X,70('-'),/,2X,'MOLEFR.',3(7X,'G1',7X,'G2   '))
      DO 140 J=1,21
      X1=FLOAT(J-1)*0.05
      DO 120 I=1,IJ
      X2=1.-X1
      G12=EXP(-A12*T12F(I))
      G21=EXP(-A12*T21F(I))
      G1=(X2*X2*T21F(I)*G21*G21)/((X1+X2*G21)**2)
      G1=G1+(X2*X2*T12F(I)*G12)/((X2+X1*G12)**2)
      G1S(I)=EXP(G1)
      G2=(X1*X1*T12F(I)*G12*G12)/((X2+X1*G12)**2)
      G2=G2+(X1*X1*T21F(I)*G21)/((X1+X2*G21)**2)
  120 G2S(I)=EXP(G2)
  140 WRITE(*,1500) X1,G1S(1),G2S(1),G1S(2),G2S(2),G1S(3),G2S(3)
 1500 FORMAT(3X,F4.2,3(2X,F7.4,1X,F7.4))
      STOP
      END
 
